#include <stdio.h>
#include "stm32f4xx.h"

void Java_app_DAC_DACInit(void) {
	
	printf("DAC init\n");
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_DAC, ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
	
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin		= GPIO_Pin_5;
	GPIO_InitStructure.GPIO_Speed 	= GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode 	= GPIO_Mode_AN;
	GPIO_InitStructure.GPIO_PuPd	= GPIO_PuPd_NOPULL;

	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	DAC_InitTypeDef  DAC_InitStructure;
	DAC_InitStructure.DAC_Trigger = DAC_Trigger_None;
  DAC_InitStructure.DAC_WaveGeneration = DAC_WaveGeneration_None;
  DAC_InitStructure.DAC_OutputBuffer = DAC_OutputBuffer_Enable;
  DAC_Init(DAC_Channel_2, &DAC_InitStructure);
	DAC_Cmd(DAC_Channel_2, ENABLE);
	
	DAC_SetChannel2Data(DAC_Align_12b_L, 0x0);
}

void Java_app_DAC_DACSetValue(int value) {
	printf("DAC set value %d\n", value);
	
	uint32_t data = value * 4095 / 3000;
	
	
	DAC_SetChannel2Data(DAC_Align_12b_R, (uint16_t)data);
}
